#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include <termios.h>

using namespace std;
void gotoxy(int x, int y)
{
	printf("%c[%d;%df",0x1B,y,x);
}

// As we have discussed, the following function will accept a input character from user,
// do not echo the input character (means do not display the character at output terminal)
// and also does not wait for ENTER key from user to proceed. In short, as soon as user enter
// any character it proceeds.
// Returns a character pressed by user.

char getch() 
{
        char buf = 0;
        struct termios old = {0};
        if (tcgetattr(0, &old) < 0)
                perror("tcsetattr()");
        old.c_lflag &= ~ICANON;
        old.c_lflag &= ~ECHO;
        old.c_cc[VMIN] = 1;
        old.c_cc[VTIME] = 0;
        if (tcsetattr(0, TCSANOW, &old) < 0)
                perror("tcsetattr ICANON");
        if (read(0, &buf, 1) < 0)
                perror ("read()");
        old.c_lflag |= ICANON;
        old.c_lflag |= ECHO;
        if (tcsetattr(0, TCSADRAIN, &old) < 0)
                perror ("tcsetattr ~ICANON");
        return (buf);
}

// the above thing is given to me by our TA. which is for getch() function

//this is for time validation . no matter what user enters ....be it characters or any space bar key or something else.

int Time_Validation(int n1,int n2,int n3,int n4)
{
	if(n1<0||n2<0||n3<0||n4<0||n1>2||n3>5||(n1==2 && n2>3)||n2>9||n3>9||n4>9)
	return 0;

else return 1;

}
void Get_Time(char time[5])
{	int i;
	for(i=0;i<=3;i++)
	{
		time[i]=getch();
		cout<<time[i];
		if(i==1) cout<<" : ";
	}
	cout<<"\n";
}
int main()
{
	char t[5];
	cout<<"enter the time\n";
	Get_Time(t);
	while(Time_Validation(t[0]-48,t[1]-48,t[2]-48,t[3]-48)==0)
	{
		cout<<"invalid time entered   "<<"enter again\n";
		Get_Time(t);
 	}
	return 1;
}

